
/*
 * Step9:
 * Program exit by killing main thread, check also stack unwinding.
 */

#include <iostream.h>
#include <stdlib.h>

#include "Pi2API.h"
#include "TestAPI.h"

static int iStackUnwound = 0;
class Dummy
{
public:
	Dummy()
		{
		cout << "Dummy Constructed" << endl;
		};
	~Dummy()
		{
		cout << "Dummy destructed" << endl;
		iStackUnwound = 1;
		};
};

int iRet;
void foo()
{
	Dummy d;
	iRet = 0;
	PIThread_terminate( PIThread_getMain(), 37 );
	FAILED(1);
}

void Step9( PIDB * )
{
	iRet = -1;
	foo();
}

int main()
{
	if ( PIProgram_enter( "dummy", PIPROGRAM_VERSION_1_0, Step9 ) )
		{
		cout << "Program_enter() failed." << endl;
		FAILED(99);
		exit( 1 );
		};
	if ( !iStackUnwound )
		{ FAILED(2); return -1; };
	OK;

	return iRet;
}

